"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.encryptionMiddleware = encryptionMiddleware;
exports.encryptModels = encryptModels;
exports.encryptModel = encryptModel;
exports.manualEncrypt = manualEncrypt;
exports.manualDecrypt = manualDecrypt;
require("reflect-metadata");
const tsyringe_1 = require("tsyringe");
const handler_1 = require("./handler");
function encryptionMiddleware(options) {
    const handler = tsyringe_1.container.resolve(handler_1.PrismaEncrypter);
    handler.setOptions(options);
    return handler.middleware.bind(handler);
}
function encryptModels(models) {
    const handler = tsyringe_1.container.resolve(handler_1.PrismaEncrypter);
    handler.addModels(models);
}
function encryptModel(model) {
    const handler = tsyringe_1.container.resolve(handler_1.PrismaEncrypter);
    handler.addModels([model]);
}
function manualEncrypt(value, key, iv, algorithm) {
    const handler = tsyringe_1.container.resolve(handler_1.PrismaEncrypter);
    return handler.rawEncrypt(value, key, iv, algorithm);
}
function manualDecrypt(value, key, iv, algorithm) {
    const handler = tsyringe_1.container.resolve(handler_1.PrismaEncrypter);
    return handler.rawDecrypt(value, key, iv, algorithm);
}
//# sourceMappingURL=index.js.map