"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IEncrypterOptions = exports.IEncrypterModel = exports.IEncrypterModelInfos = exports.IEncrypterInfos = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
class IEncrypterInfos {
}
exports.IEncrypterInfos = IEncrypterInfos;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.Min)(32),
    __metadata("design:type", String)
], IEncrypterInfos.prototype, "key", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.Length)(16, 16),
    __metadata("design:type", String)
], IEncrypterInfos.prototype, "iv", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsString)(),
    __metadata("design:type", String)
], IEncrypterInfos.prototype, "algorithm", void 0);
class IEncrypterModelInfos extends IEncrypterInfos {
}
exports.IEncrypterModelInfos = IEncrypterModelInfos;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsString)(),
    __metadata("design:type", String)
], IEncrypterModelInfos.prototype, "ivField", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], IEncrypterModelInfos.prototype, "stripIvField", void 0);
class IEncrypterModel {
}
exports.IEncrypterModel = IEncrypterModel;
__decorate([
    (0, class_validator_1.IsString)(),
    __metadata("design:type", String)
], IEncrypterModel.prototype, "model", void 0);
__decorate([
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsOptional)(),
    __metadata("design:type", Array)
], IEncrypterModel.prototype, "fields", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Type)(() => IEncrypterInfos),
    __metadata("design:type", IEncrypterModelInfos)
], IEncrypterModel.prototype, "local", void 0);
class IEncrypterOptions {
}
exports.IEncrypterOptions = IEncrypterOptions;
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], IEncrypterOptions.prototype, "logging", void 0);
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Type)(() => IEncrypterInfos),
    __metadata("design:type", IEncrypterInfos)
], IEncrypterOptions.prototype, "global", void 0);
__decorate([
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.ValidateNested)({ each: true }),
    (0, class_validator_1.ArrayMinSize)(1),
    (0, class_transformer_1.Type)(() => IEncrypterModel),
    __metadata("design:type", Array)
], IEncrypterOptions.prototype, "models", void 0);
//# sourceMappingURL=options.js.map